/* variables */
@font-face {
    font-family: "Chelsea Market";
    src: url("/assets/fonts/ChelseaMarket-Regular.ttf") format("truetype");
}

@font-face {
    font-family: "Sawarabi Gothic";
    src: url("/assets/fonts/SawarabiGothic-Regular.ttf") format("truetype");
}

:root {
    /* background color and image */
    --bg-color: rgba(0, 0, 0, 0.99);
    --bg-image: url("/assets/images/background/noise-1.gif");

    /* fonts */
    --font: "Chelsea Market";
    --japanese-font: "Sawarabi Gothic";

    /* text colors */
    --text-color: rgb(174, 182, 184);
    --text-glow: 0 0 5px var(--detail-color-light);
    --text-accent-color: rgb(200, 206, 206);
    --text-accent-glow: 0 0 3px var(--text-color);

    /* accent colors */
    --accent-color: rgb(138, 15, 28);
    --accent-color-glow: 0 0 5px var(--accent-color-semi);
    --accent-color-hover: rgb(158, 40, 40);
    --accent-color-hover-glow : 0 0 8px var(--accent-color);
    --accent-color-semi: rgba(138, 15, 28, 0.5);

    /* surface color */
    --surface-color: black;

    /* detail colors */
    --detail-color: rgb(35, 37, 39);
    --detail-color-light: rgb(57, 59, 61);

    /* border styling */
    --border: 1px solid var(--detail-color);
    --glow: 0 0 4px var(--detail-color);

    /* cubic bezier */
    --cubic-bezier: cubic-bezier(0.25, 0.10, 0.25, 1);

    /* rainbow colors */
    --red: rgb(204, 31, 31);
    --orange: rgb(235, 67, 25);
    --yellow: rgb(199, 169, 35);
    --green: rgb(83, 212, 44);
    --blue: rgb(44, 205, 216);
    --indigo: rgb(76, 92, 240);
    --violet: rgb(156, 52, 226);

    /* system members' individual colors */
    --vile: #04050f;
    --vile-light: #202ba0;
    --spade: rgb(202, 171, 31);
    --spade-light: rgb(184, 141, 0);
    --azure: #142880;
    --azure-light: #0622a0;
    --tsunami: #1c74d8;
    --rock: rgb(105, 26, 75);
    --rock-light: rgb(179, 32, 122);
    --void: #991313;
    --robin: #52287f;
    --robin-light: #7e44bd;
    --sweet: #861ac9;
    --tachimukai: #67b2bf;
    --leaf: #2cd32f;
    --robin-b: #91df3f;
}

/* base */
* {
    box-sizing: border-box;
    margin: 0;
    padding: 0;
    scrollbar-color: var(--detail-color) var(--surface-color);
    scrollbar-width: thin;
    scroll-behavior: smooth;
    scrollbar-gutter: auto;
    align-self: center;
}

html {
    background-color: var(--surface-color);
}

html, body {
    width: 100vw;
    height: 100vh;
    overflow: hidden;
    
}

body {
    background-image: var(--bg-image);
    background-color: var(--bg-color);
    background-blend-mode: hard-light;
}

br {
    display: block;
    content: " ";
    margin: 0.5rem 0;
}

hr {
    width: 100%;
    border: none;
    border-top: var(--border);
    margin: 1rem 0;
    box-shadow: var(--glow);
}

mark {
    background: linear-gradient(90deg, var(--accent-color-semi) 60%, transparent);
    color: var(--text-accent-color);
    text-shadow: var(--text-accent-glow);
    padding: 0.2rem;
}

::selection {
    background-color: var(--accent-color-semi);
    color: var(--text-accent-color);
    text-shadow: var(--text-accent-glow);
}

/* layout */
/* utility classes */
.flex {
    display: flex;
    gap: 0;
}

.gap-0-5-rem {
    gap: 0.5rem;
}

.gap-1-rem {
    gap: 1rem;
}

.gap-1-5-rem {
    gap: 1.5rem;
}

.gap-2-rem {
    gap: 2rem;
}

.flex-column {
    flex-direction: column;
}

.flex-row {
    flex-direction: row;
}

.flex-justify-center {
    justify-content: center;
}

.flex-justify-start {
    justify-content: flex-start;
}

.flex-align-center {
    align-items: center;
}

.flex-align-start {
    align-items: flex-start;
    > div {
        align-self: flex-start;
    }
}

.remove-margin-bottom {
    margin-bottom: -0.5rem !important;
}

.border {
    border: var(--border);
    box-shadow: var(--glow);
}

.grid {
    display: grid;
    align-items: start;
    max-width: 100%;
}

.grid-2-col {
    grid-template-columns: 1fr 1fr;
}

.grid-3-col {
    grid-template-columns: 1fr 3fr 1fr;
}

.grid-2-col > div, .grid-3-col > div {
    min-width: 0;
    max-width: 100%;
    align-self: start;
}

/* layout */
.wrapper {
    min-width: 400px;
    width: max-content;
    max-width: 85vw;
    min-height: 300px;
    height: max-content;
    max-height: 90vh;
    gap: 1.5rem;
}
.container {
    width: 100%;
    height: 100%;
    background: var(--surface-color);
    padding: 1rem 2rem;
    padding-bottom: 1.6rem;
    overflow-y: auto;
    overflow-x: hidden;
}

.main-content {
    text-align: center;
}

.main-content > .flex {
    gap: 0.5rem;
}

.main-text {
    margin-bottom: 0.2rem !important;
}

div:not(:last-child), div:not(:last-of-type){
    margin-bottom: 0.8rem;
}

.language-selection {
    gap: 2.5rem;
    margin-bottom: 0.5rem;
}

.changelog  {
    h1, h2, h3, h4, h5, h6 {
        text-align: center;
        margin-top: unset;
    }
}

.changelog > div {
    background: var(--surface-color);
    padding: 0.5rem 0.8rem;
    height: var(200px + 5rem);
    max-height: 500px;
    overflow-y: auto;
    margin-top: 0.3rem;

    p {
        font-family: var(--font);
    }
}

.changelog p:not(:last-of-type) {
    margin-bottom: 0.6rem;
}

/* animations */
body {
    animation: fadein 1.2s var(--cubic-bezier) forwards, blurin 1.2s var(--cubic-bezier) forwards;
}

.wrapper {
    animation: fadein ease-out 1.4s forwards, blurin ease-out 1.4s forwards;
}

.wrapper > * {
    animation: fadein ease-out 1.8s forwards, blurin ease-out 1.8s forwards;
}

@keyframes fadein {
    from {
        opacity: 0;
        transform: scale(0.80);
        transform-origin: center;
    }
    to {
        opacity: 1;
        transform: scale(1);
        transform-origin: center;
    }
}

@keyframes blurin {
    from {
        filter: blur(5px);
    }
    to {
        filter: blur(0px);
    }
}

/* components */
/* header */
header.container {
    position: relative;
    overflow: hidden;
    height: calc(100px + 5vh);
}

header.container::before {
    content: "";
    position: absolute;
    inset: 0;
    background-image: url(/assets/images/background/bats-flight.gif);
    background-size: 60%;
    background-position: center;
    background-repeat: no-repeat;
    background-color: rgba(0, 0, 0, 0.8);
    background-blend-mode: hard-light;
    filter: hue-rotate(-7deg);
    pointer-events: none;
    z-index: -1;
}

header > img {
    width: calc(230px + 3vw);
    position: absolute;
    left: 50%;
    transform: translateX(-50%);
    bottom: 20px;
    filter: hue-rotate(-3deg) brightness(90%);
}

/* navigation */
header nav {
    position: absolute;
    bottom: 0;
    left: 0;
    width: 100%;
    background: linear-gradient(transparent, black 50%);
    padding: 1.5rem 0.2rem 0.2rem 0.2rem;
    z-index: 11;
    font-size: 1.2rem;
    font-weight: bold;
}

nav > ul.flex {
    list-style: none;
    gap: 3vw;
    margin: 0;
    flex-wrap: wrap;
}

nav li {
    margin-bottom: unset !important;
}

/* footer */
footer.container {
    height: auto;
    overflow: hidden;
    padding: 0.5rem 1rem;
    text-align: center;
}

span.copyright-symbol {
    position: relative;
    top: 0.1rem;
}

/* language dropdown */
.language-dropdown-container {
    position: absolute;
    top: 0;
    right: 8%;
    z-index: 50;
}

.lang-btn {
    cursor: pointer;
    transition: border 0.3s ease-in-out, box-shadow 0.3s ease-in-out;
    border: var(--border);
    border-top: none;
    box-shadow: var(--glow);

    &:hover, &:focus {
        border: 1px solid var(--accent-color);
        border-top: none;
        box-shadow: var(--accent-color-glow);
    }
}

.lang-btn, .lang-menu {
    padding: 0.5rem;
    width: 50px;
    background-color: var(--surface-color);
}

.active .lang-btn {
    border-bottom-color: transparent;
}

.lang-btn img, .lang-menu img {
    width: 30px;
}

.lang-menu {
    max-height: 0px;
    position: absolute;
    top: 100%;
    left: 50%;
    transform: translateX(-50%) translateY(-10px);
    list-style: none;
    margin: 0;
    border: 1px solid var(--accent-color);
    border-top: none;
    box-shadow: var(--accent-color-glow);
    opacity: 0;
    visibility: hidden;
    transition: opacity 0.3s ease-in-out, transform 0.3s ease-in-out, visibility 0.3s ease-in-out, max-height 0.25s ease-in-out;
}

.language-dropdown-container.active .lang-menu {
    opacity: 1;
    visibility: visible;
    transform: translateX(-50%) translateY(0);
    max-height: 1000px;
}

.lang-menu a {
    opacity: 0.6;
    filter: grayscale(50%);
    transition: opacity 0.3s ease-in-out, filter 0.3s ease-in-out, transform 0.3s ease-in-out;

    &:hover {
        opacity: 1;
        filter: grayscale(0%);
    }
}

.lang-menu li {
    margin-bottom: unset !important;
}

/* rickroll */
.rickroll {
    cursor: pointer;
    transition: transform 0.3s ease-in-out, filter 0.3s ease-in-out;
    text-align: center;

    &:hover {
        transform: scale(1.05);
        filter: brightness(1.1);
    }
}

/* textarea */
textarea {
    border: var(--border);
    box-shadow: var(--glow);
    background-color: var(--surface-color);
    color: var(--text-color);
    resize: vertical;
    width: 100%;
    padding: 0.5rem;
}

/* drawbox */
#drawboxcanvas {
    border: var(--border);
    box-shadow: var(--glow);
    cursor: crosshair;
    max-width: 100%;
    max-height: 100vw;
    aspect-ratio: 1 / 1;
}

#gallery {
    display: flex;
    flex-wrap: wrap;
    gap: 10px;
}

.image-container {
    border: var(--border);
    box-shadow: var(--glow);
    padding: 5px;
    max-width: 200px;
    text-align: center;
}

.image-container img {
    max-width: 100%;
    height: auto;
    display: block;
}

/* buttons */
button {
    font-size: 1rem;
    border: var(--border);
    box-shadow: var(--glow);
    background-color: var(--surface-color);
    color: var(--text-color);
    cursor: pointer;
    padding: 0.3rem;
    transition: border 0.3s ease-in-out, box-shadow 0.3s ease-in-out, font-size 0.3s ease-in-out;

    &:hover {
        border: 1px solid var(--accent-color);
        box-shadow: var(--accent-color-glow);
        font-size: 1.2rem;
    }
}

input {
    border: var(--border);
    box-shadow: var(--glow);
    background-color: var(--surface-color);
    color: var(--text-color);
}

/* guestbook */
.guestbook iframe {
    width: 100%;
    height: 600px;
    border: var(--border);
    box-shadow: var(--glow);
    overflow: auto;
}

/* marquees */
.marquee-container {
    width: 100%;
    margin: 0.5rem 0;
    mask-image: linear-gradient(to right, transparent, black 5%, black 95%, transparent);
    padding: 0.3rem 0;

    img {
        vertical-align: middle;
        margin-right: 0.5rem;
    }

    > div {
        width: max-content;
        gap: 0;
    }
}

@keyframes scroll-left {
    from {
        transform: translateX(0);
    }
    to {
        transform: translateX(-50%);
    }
}

@keyframes scroll-right {
    0% {
        transform: translateX(-100%);
    }
    100% {
        transform: translateX(95vw);
    }
}

.buttons.marquee {
    animation: scroll-left 50s linear infinite;

    img {
        max-width: 88px;
        max-height: 31px;
    }

    &:hover {
        animation-play-state: paused;
    }
}

.blinkies.marquee {
    animation: scroll-left 50s linear infinite;

    img {
        max-height: 20px;
    }

    &:hover {
        animation-play-state: paused;
    }
}

.welcome.marquee {
    animation: scroll-right 25s linear infinite;
    width: max-content;
    white-space: nowrap;
    
    img {
        filter: drop-shadow(0 0 3px var(--accent-color));
    }
}

/* tables */
table {
    border: var(--border);
    box-shadow: var(--glow);
    border-collapse: collapse;
    margin: 0.4rem 0 1.2rem 0;
}

th, td {
    border: var(--border);
    padding: 0.5rem 1rem;
    text-align: center;
}

/* typography */

/* japanese */
*:lang(jp), *:lang(ja), .ja {
    font-family: var(--japanese-font);
    font-size: calc(16px + 0.2vw);

    p:not(:last-of-type) {
        margin-bottom: 0;

    }

    br {
        margin: 0.25rem 0;
    }

    ul:not(:last-child), ul:not(:last-of-type), ol:not(:last-child), ol:not(:last-of-type) {
        margin-bottom: 0rem;
    }
    
    li {
        line-height: 1.6;
        &:not(:last-child), &:not(:last-of-type) {
            margin-bottom: 0;
        }
    }
}

/* base */
body {
    font-family: var(--font);
    font-size: calc(14px + 0.2vw);
    color: var(--text-color);
    line-height: 1.6;
    text-shadow: var(--text-glow);
    letter-spacing: 0.03rem;
}

.text-center {
    text-align: center;
    min-width: 0;
    max-width: 100%;
    
    > * {
        vertical-align: middle;
    }
}

/* links */
a {
    display: inline-block;
    color: var(--accent-color);
    text-decoration: none;
    text-shadow: var(--accent-color-glow);
    transition: transform 0.3s ease-in-out, color 0.3s ease-in-out, text-shadow 0.3s ease-in-out;

    &:hover, &:focus {
        transform: scale(1.1);
        color: var(--accent-color-hover);
        text-shadow: var(--accent-color-hover-glow);
    }

    > h1, h2, h3, h4, h5, h6 {
        color: inherit;
        text-shadow: inherit;
    }
}

/* headings */
h1, h2, h3, h4, h5, h6, strong, b {
    color: var(--text-accent-color);
    text-shadow: var(--text-accent-glow);
    font-weight: bold;
}

h1, h2, h3, h4, h5, h6 {
    margin-top: -0.2rem;
    margin-bottom: 0;
    letter-spacing: 0.06rem;
    line-height: 1.2;
    margin-bottom: 0.3rem;
}

h1, h1:lang(jp), h1:lang(ja) {font-size: 1.7rem;}

h2, h2:lang(jp), h2:lang(ja) {font-size: 1.5rem;}

h3, h3:lang(jp), h3:lang(ja) {font-size: 1.4rem;}

h4, h4:lang(jp), h4:lang(ja) {font-size: 1.3rem;}

h5, h5:lang(jp), h5:lang(ja) {font-size: 1.2rem;}

h6, h6:lang(jp), h6:lang(ja) {font-size: 1.1rem;}

/* paragraphs */
p:not(:last-of-type) {
    margin-bottom: 0.2rem;
}

/* lists */
ul {
    list-style-image: url(/assets/images/icons/rotating-skull.gif);
    text-align: left;

    > p {
        margin-left: -1.5rem;
        margin-bottom: 0.2rem;
        margin-top: -0.2rem;
    }
}

ul, ol {
    margin-left: 1.5rem;
}

ol ::marker {
    color: var(--text-accent-color);
    text-shadow: var(--text-accent-glow);
}

ul:not(:last-child), ul:not(:last-of-type), ol:not(:last-child), ol:not(:last-of-type) {
    margin-bottom: 1rem;
}

ul:has(+ hr), ol:has(+ hr) {
    margin-bottom: 0 !important;
}

li {
    line-height: 1.8;
    &:not(:last-child), &:not(:last-of-type) {
        margin-bottom: 0.25rem;
    }
}

.faded {
    opacity: 0.5;
    transform: scale(0.9);
}

/* rainbow text */
.rainbow-text {
    background: linear-gradient(90deg, var(--red), var(--orange), var(--yellow), var(--green), var(--blue), var(--indigo), var(--violet), var(--red));
    background-size: 200% 100%;
    background-clip: text;
    color: transparent;
    -webkit-text-fill-color: transparent;
    animation: rainbow 5s linear infinite;
    position: relative;
    text-shadow: none;
    transition: filter 0.3s ease-in-out;

    &:hover {
        filter: saturate(100%) brightness(1.1);
    }
}

.rainbow-text::before {
    content: attr(data-text);
    position: absolute;
    left: 0;
    top: 0;
    z-index: -2;
    background: inherit;
    background-size: inherit;
    background-clip: text;
    -webkit-text-fill-color: transparent;
    filter: blur(4px) saturate(200%);
    animation: inherit;
    transition: filter 0.3s ease-in-out;
}

.rainbow-text:hover::before {
    filter: blur(6px) saturate(300%) brightness(2);
}

@keyframes rainbow {
    0% {
        background-position: 0% 50%;
    }
    100% {
        background-position: 200% 50%;
    }
}

/* media query */
/* reduced motion */
@media (prefers-reduced-motion: reduce) {
    .petals-container img {
        display: none;
    }

    body {
        animation: none;
    }

    .rainbow-text {
        animation: none;
        color: var(--accent-color);
    }
}

/* layout */
@media (max-width: 1280px) {
    .wrapper {
        max-width: 90vw;
    }

    .grid-3-col {
        grid-template-columns: 1fr 2fr 1fr;
    }

    .main-content > .flex-row {
        flex-direction: column;
        gap: 0;
    }

    .art {
        max-width: 100%;
        max-height: 100%;
    }

    div:has(> .art) {
        margin-bottom: 0.2rem;
    }
}

@media (max-width: 1150px) {
    .gap-2-rem.grid {
        gap: 1.5rem;
    }
}

@media (max-width: 1100px) {
    .wrapper {
        max-width: 95vw;
    }

    main.container {
        padding: 1rem 1.5rem;
    }
}

@media (max-width: 1050px) {
    .grid-3-col {
        grid-template-columns: 28% auto 28%;
    }
}

@media (max-width: 960px) {
    nav > ul.flex {
        gap: 0;
        justify-content: center;
    }

    nav li:not(:last-of-type) {
        margin-right: 1.2rem;
    }

    header.container::before {
        background-color: rgba(0, 0, 0, 0.9);
    }
}

@media (max-width: 900px) {
    header > img {
        display: none;
    }

    header nav {
        padding: 1.5rem 10rem 0.2rem 10rem;
        background: linear-gradient(transparent, black 35%);
    }
}

@media (max-width: 860px) {
    .grid-3-col {
        grid-template-columns: 30% auto 30%;
    }
}

@media (max-width: 820px) {
    header nav {
        padding: 1.5rem 6rem 0.2rem 6rem;
    }
}

@media (max-width: 800px) {
    body {
        font-size: calc(14px + 0.5vw);
    }

    .grid {
        display: flex;
        flex-direction: column;
        gap: 1rem;
    }

    .grid-2-col > div, .grid-3-col > div {
        align-self: stretch;
    }

    .flex-column {
        align-items: center;
    }

    main.container {
        padding: 0.5rem 1.5rem 1.5rem 1.5rem;
    }

    .language-dropdown-container {
        right: 6%;
    }

    .art {
        max-width: 85%;
        max-height: unset;
    }

    .image-modal-content {
        max-width: 80vw;
        max-height: 80vh;
    }

    div:has(> .art), div.main-content, #gallery, div.sidebar {
        margin-bottom: 0.2rem;
    }

    .marquee-container:has(> .blinkies) {
        margin-bottom: 0;
    }

    div.main-content {
        order: 1;
    }

    .sidebar {
        order: 2;
    }

    .rickroll {
        margin-top: -0.3rem;
        margin-bottom: 1.2rem !important;
    }

    .rickroll img {
        max-width: 300px;
    }

    .marquee-container:has(> .welcome) {
        margin-bottom: 0.3rem;
    }

    header.container::before {
        background-size: 80%;
    }

    .lang-btn img, .lang-menu img {
        width: 25px;
    }

    .lang-btn, .lang-menu {
        width: 40px;
        padding: 0.3rem;
    }

    .lang-menu {
        padding: 0 0.3rem;
    }
}

@media (max-width: 680px) {
    header nav {
        padding: 1.5rem 3rem 0.2rem 3rem;;
    }

    header.container {
        height: calc(80px + 5vw);
    }

    header.container::before {
        background-size: 100%;
    }
}

@media (max-width: 600px) {
    .lang-btn img, .lang-menu img {
        width: 20px;
    }

    .lang-btn, .lang-menu {
        width: 35px;
    }
}

@media (max-width: 580px) {
    header nav {
        padding: 1.5rem 1rem 0.2rem 1rem;
    }
}

@media (max-width: 510px) {
    header nav {
        background: linear-gradient(transparent, black 35%);
        bottom: auto;
        top: 50%;
        transform: translateY(-50%);
        height: 100%;
        padding: 0.5rem;
        display: flex;
        align-items: center;
    }

    header.container {
        height: calc(100px + 5vw);
    }

    .welcome.marquee {
        animation: scroll-right 15s linear infinite;
    }

    .image-modal-content {
        max-width: 85vw;
        max-height: 85vh;
    }

    .wrapper {
        min-width: unset;
    }

    div.socials {
        flex-wrap: wrap;
        gap: 1.5rem;
    }
}

@media (max-width: 490px) {
    header.container {
        height: calc(120px + 5vw);
    }

    header nav {
        background: linear-gradient(transparent, black 80%);
    }

    header.container::before {
        background-color: rgba(0, 0, 0, 0.6);
        background-blend-mode: multiply;
    }
}

@media (max-width: 380px) {
    header.container {
        height: calc(150px + 5vw);
    }
}